#include <windows.h>
#include <Windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include <Shlwapi.h>

#include "resource.h"
#include "settings.h"
#include "chat.h"
#include "control.h"
#include "main.h"

#include "signature.h"
#include "..\Audio\codec_interface.h"
//----------------------------------------------------------------------------
typedef struct {
	NODE nd;
	UINT msg_height;
	CONTR_PROT* contr;
	SPEEX_CODEC* codec;
} chat_t;
//----------------------------------------------------------------------------
static void dialClicked(HWND hWnd)
{
    chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	ch->contr->dial();

//	if (ch->contr->getState() > CTRL_ST_CONNECTED) SetDlgItemText(hWnd,IDC_DIAL,TEXT("Hung down"));
//    else SetDlgItemText(hWnd,IDC_DIAL,TEXT("Dial"));
	if (ch->contr->getState() > CTRL_ST_CONNECTED) SendDlgItemMessage(hWnd, IDC_DIAL, BM_SETIMAGE, IMAGE_ICON, (LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_PHONE_RED)));
	else SendDlgItemMessage(hWnd, IDC_DIAL, BM_SETIMAGE, IMAGE_ICON, (LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_PHONE_GREEN)));
}
//----------------------------------------------------------------------------
static void sendMsg(HWND hWnd)
{
	chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	int msgSize = Edit_GetTextLength(GetDlgItem(hWnd,IDC_MESSAGE));
	if (!msgSize) return;
	int chatSize = Edit_GetTextLength(GetDlgItem(hWnd,IDC_CHAT));
	TCHAR* strMsg = (TCHAR*)HeapAlloc(GetProcessHeap(),0,(msgSize+1)*sizeof(TCHAR));
	TCHAR* strChat = (TCHAR*)HeapAlloc(GetProcessHeap(),0,(chatSize+msgSize+10)*sizeof(TCHAR));
	GetDlgItemText(hWnd,IDC_MESSAGE,strMsg,msgSize+1);
	GetDlgItemText(hWnd,IDC_CHAT,strChat,chatSize+msgSize+10);
	_tcscat_s(strChat,chatSize+msgSize+10,TEXT("> "));
	_tcscat_s(strChat,chatSize+msgSize+10,strMsg);
	_tcscat_s(strChat,chatSize+msgSize+10,TEXT("\r\n"));
	SetDlgItemText(hWnd,IDC_CHAT,strChat);
	Edit_SetSel(GetDlgItem(hWnd,IDC_CHAT),cp_strlen(strChat)-1,cp_strlen(strChat)-1);
	Edit_ScrollCaret(GetDlgItem(hWnd,IDC_CHAT));
	SetDlgItemText(hWnd,IDC_MESSAGE,TEXT(""));
	ch->contr->sendMessage(strMsg);
	HeapFree(GetProcessHeap(),0,strMsg);
	HeapFree(GetProcessHeap(),0,strChat);
	SetFocus(GetDlgItem(hWnd,IDC_MESSAGE));
}
//----------------------------------------------------------------------------
static void showText(HWND hWnd,LPTSTR text, u32 textSize)
{
	chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	int chatSize = Edit_GetTextLength(GetDlgItem(hWnd,IDC_CHAT));
	TCHAR* strChat = (TCHAR*)HeapAlloc(GetProcessHeap(),0,(chatSize+textSize+5)*sizeof(TCHAR));
	GetDlgItemText(hWnd,IDC_CHAT,strChat,chatSize+textSize+5);
	_tcscat_s(strChat,chatSize+textSize+5,TEXT("< "));
	memcpy(&strChat[chatSize+2],text,textSize);
	strChat[chatSize+2+textSize/sizeof(TCHAR)] = 0;
	_tcscat_s(strChat,chatSize+textSize+5,TEXT("\r\n"));
	SetDlgItemText(hWnd,IDC_CHAT,strChat);
	Edit_SetSel(GetDlgItem(hWnd,IDC_CHAT),cp_strlen(strChat)-1,cp_strlen(strChat)-1);
	Edit_ScrollCaret(GetDlgItem(hWnd,IDC_CHAT));
	HeapFree(GetProcessHeap(),0,strChat);
}
//----------------------------------------------------------------------------
void change_voice(HWND hWnd, s16* data_mic, s16* data_loud)
{
 	chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	s16 speaker_data[FRAME_SIZE];
	s16 mic_ec_data[FRAME_SIZE];
	u32 real_size;
	
	if (!ch || (ch->contr->getState() != CTRL_ST_IN_VOICE)) return;

    u8* pack_data = ch->contr->getVoice(&real_size);
    ch->codec->Unpack_Audio_Data(speaker_data,pack_data,real_size);
	if (pack_data) delete[] pack_data;
	if (data_loud)
	{
		for (u32 i = 0; i < FRAME_SIZE; i++)
			data_loud[i] += speaker_data[i];
	}
	
	ch->codec->Process_EC(mic_ec_data,data_mic,speaker_data);

    u32 pack_size = ch->codec->Pack_Audio_Data((u8*)speaker_data,mic_ec_data);
    ch->contr->sendVoice((u8*)speaker_data,pack_size);
}
//----------------------------------------------------------------------------
static const LPTSTR status_txt[CTRL_ST_LAST] = {TEXT("IDLE"),TEXT("CONNECTION"),TEXT("CONNECTED"),TEXT("DIALING"),TEXT("IN VOICE"),TEXT("IN HOLD")};
static void updateStatus(HWND hWnd)
{
	chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	u32 state = ch->contr->getState();
	ch->contr->process();
	SendDlgItemMessage(hWnd,IDC_STATUS,SB_SETTEXT,0,(LPARAM)status_txt[state]);
	if ((state == CTRL_ST_IN_VOICE) || (state == CTRL_ST_HOLD))
		SetDlgItemText(hWnd,IDC_DIAL,TEXT("Hang down"));
	else
		SetDlgItemText(hWnd,IDC_DIAL,TEXT("Dial"));
	// network counters
	u32 est,sec,sent,drop;
	TCHAR str[200];
	getNet()->get_counters(&ch->nd,&est,&sec,&drop,&sent);
	_stprintf_s(str,200,TEXT("packets overhead: %d, secured: %d, dropped: %d, sent: %d"),est,sec,drop,sent);
	SendDlgItemMessage(hWnd,IDC_STATUS,SB_SETTEXT,1,(LPARAM)str);
	// volume
	SendDlgItemMessage(hWnd,IDC_VOLUME,TBM_SETPOS,TRUE,getVolume());
	SendDlgItemMessage(hWnd,IDC_MICLEVEL,TBM_SETPOS,TRUE,getMicrophone());
}
//----------------------------------------------------------------------------
static void ChatSizing(HWND hWnd, WPARAM wParam, LPRECT newWndRect)
{
	RECT oldWndRect;
	RECT oldClientRect;
	const LONG lMinWidth = 200;
	const LONG lMinHeight = 300;
	//
	GetWindowRect(hWnd, &oldWndRect);
	GetClientRect(hWnd, &oldClientRect);
	//
	oldClientRect.right -= oldWndRect.right - oldWndRect.left - (newWndRect->right - newWndRect->left);		// calculate new client width
	oldClientRect.bottom -= oldWndRect.bottom - oldWndRect.top - (newWndRect->bottom - newWndRect->top);	// calculate new client height
	// adjust width
	if (oldClientRect.right < lMinWidth){
		switch (wParam)
		{
		case WMSZ_BOTTOMLEFT:
		case WMSZ_LEFT:
		case WMSZ_TOPLEFT:
			newWndRect->left -= lMinWidth - oldClientRect.right;
			break;
			//
		default:
			newWndRect->right += lMinWidth - oldClientRect.right;
		}
	}
	// adjust height
	if (oldClientRect.bottom < lMinHeight){
		switch (wParam)
		{
		case WMSZ_TOPLEFT:
		case WMSZ_TOP:
		case WMSZ_TOPRIGHT:
			newWndRect->top -= lMinHeight - oldClientRect.bottom;
			break;
			//
		default:
			newWndRect->bottom += lMinHeight - oldClientRect.bottom;
		}
	}
}
//----------------------------------------------------------------------------
static void ChatSize(HWND hWnd)
{
	chat_t* ch = (chat_t*)GetProp(hWnd,TEXT("chat"));
	RECT mrc,rc,txt;
	int mainHeight;
	int w;
	GetClientRect(hWnd,&mrc);

	GetWindowRect(GetDlgItem(hWnd,IDC_STATUS),&rc);
	mainHeight = mrc.bottom-mrc.top-4-(rc.bottom-rc.top)-ch->msg_height-36;
	if (mainHeight < 16)
	{
		ch->msg_height += 16-mainHeight;
		mainHeight = 16;
	}
	MoveWindow(GetDlgItem(hWnd,IDC_CHAT),0,0,mrc.right,mainHeight,TRUE);
	MoveWindow(GetDlgItem(hWnd,IDC_MESSAGE),0,mainHeight+4,mrc.right,ch->msg_height,TRUE);
	GetClientRect(GetDlgItem(hWnd,IDC_VOLUME_STR),&txt);
	w = mrc.right-4-2*txt.right;
	MoveWindow(GetDlgItem(hWnd,IDC_DIAL),2,mainHeight+4+ch->msg_height+2,32,32,TRUE);
	MoveWindow(GetDlgItem(hWnd,IDC_VOLUME_STR),2+32,mainHeight+4+ch->msg_height+2+8,txt.right,14,TRUE);
	MoveWindow(GetDlgItem(hWnd,IDC_VOLUME),2+32+txt.right,mainHeight+4+ch->msg_height+2+4,(w-32)/2,26,TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_MIC_STR), 2 + 32 + (w - 32) / 2 + txt.right, mainHeight + 4 + ch->msg_height + 2 + 8, txt.right, 14, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_MICLEVEL), 2 + 32 + (w - 32) / 2 + 2 * txt.right, mainHeight + 4 + ch->msg_height + 2+4, (w - 32) / 2, 26, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_STATUS), 0, mrc.bottom - (rc.bottom - rc.top), mrc.right, rc.bottom - rc.top, TRUE);
}
//----------------------------------------------------------------------------
static void ChatInit(HWND hWnd, NODE* nd)
{
	chat_t* ch = (chat_t*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(chat_t));
	ch->msg_height = 60;
	ch->nd = *nd;
	ch->contr = new CONTR_PROT(nd,GetParent(hWnd),hWnd);
	ch->codec = new SPEEX_CODEC();
	SetProp(hWnd,TEXT("chat"),ch);
	SetTimer(hWnd,1,1000,NULL);
	ShowWindow(GetDlgItem(hWnd,IDC_SEND_MESSAGE),SW_HIDE);
	int parts[]={100,-1};
	SendDlgItemMessage(hWnd,IDC_STATUS,SB_SETPARTS,sizeof(parts)/sizeof(parts[0]),(LPARAM)parts);
	updateStatus(hWnd);

/*	BUTTON_IMAGELIST bil; 
	bil.himl = ImageList_Create(32, 32, ILC_COLOR32, 2, 1);
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_PHONE_GREEN)));
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_PHONE_RED)));
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_GREY_USER)));
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_GREEN_USER)));
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_GREEN)));
	ImageList_AddIcon(bil.himl, LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_MAIN)));
	bil.margin.top = 0;
	bil.margin.left = 0;
	bil.margin.bottom = 30;
	bil.margin.right = 30;
	bil.uAlign = BUTTON_IMAGELIST_ALIGN_CENTER;
	Button_SetImageList(GetDlgItem(hWnd, IDC_DIAL), &bil);*/
	SendDlgItemMessage(hWnd, IDC_DIAL, BM_SETIMAGE, IMAGE_ICON, (LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_PHONE_GREEN)));
	ChatSize(hWnd);
}
//----------------------------------------------------------------------------
static void ChatDestroy(HWND hWnd)
{
	KillTimer(hWnd,1);
	chat_t* ch = (chat_t*)RemoveProp(hWnd,TEXT("chat"));
	delete ch->contr;
	delete ch->codec;
	HeapFree(GetProcessHeap(),0,ch);
	PostMessage(GetParent(hWnd),WM_DELETECHAT,0,(LPARAM)hWnd);
}
//----------------------------------------------------------------------------
static INT_PTR CALLBACK ChatProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		ChatInit(hWnd,(NODE*)lParam);
		return TRUE;
		//
    case WM_DESTROY:
		ChatDestroy(hWnd);
		return TRUE;
		//
	case WM_SIZE:
		ChatSize(hWnd);
		return 0;
		//
	case WM_SIZING:
		ChatSizing(hWnd, wParam, (LPRECT)lParam);
		return TRUE;
		//
	case WM_CLOSE:
		DestroyWindow(hWnd);
		return TRUE;
		//
	case WM_TIMER:
		updateStatus(hWnd);
		return TRUE;
		//
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_DIAL:
			dialClicked(hWnd);
			return TRUE;
		case IDC_SEND_MESSAGE:
			sendMsg(hWnd);
			return TRUE;
		}
		return FALSE;
	case WM_HSCROLL:
		if (((HWND)lParam == GetDlgItem(hWnd,IDC_VOLUME)) && (LOWORD(wParam) == TB_THUMBPOSITION || LOWORD(wParam) == TB_THUMBTRACK))
		{
			setVolume(HIWORD(wParam));
		}
		if (((HWND)lParam == GetDlgItem(hWnd,IDC_MICLEVEL)) && (LOWORD(wParam) == TB_THUMBPOSITION || LOWORD(wParam) == TB_THUMBTRACK))
		{
			setMicrophone(HIWORD(wParam));
		}
		break;
	case WM_PROCESSDATA:
		((chat_t*)GetProp(hWnd,TEXT("chat")))->contr->received((u32*)lParam,(u32)wParam);
		return TRUE;
	case WM_CHANGE_VOICE:
		change_voice(hWnd,(s16*)wParam,(s16*)lParam);
		return TRUE;
	case WM_SHOWTEXT:
		showText(hWnd,(LPTSTR)wParam,(u32)lParam);
		return TRUE;
	}
	return FALSE;
}
//-----------------------------------------------------------------------
HWND StartChat(HWND hWnd, NODE* nd)
{
	return CreateDialogParam(GetModuleHandle(NULL),TEXT("Chat"),hWnd,ChatProc,(LPARAM)nd);
}
//-----------------------------------------------------------------------
