#include "types.h"
#include "cp_threads.h"
//---------------------------------------------------------------------
#include <stdlib.h>
//---------------------------------------------------------------------
typedef struct {
	threadproc_t proc;
	void *param;
} threadparams_t;
//---------------------------------------------------------------------
#ifdef _LINUX
void *
#elif defined(_WIN32)
DWORD CALLBACK
#endif
cp_thread_proc(void *param)
{
	threadparams_t *params = (threadparams_t*)param;
	int res;

	res = params->proc(params->param);
	free(params);
#ifdef _LINUX
	pthread_exit((void*)(_s_ptr)res);
#elif defined(_WIN32)
	ExitThread((DWORD)res);
#endif
}
//---------------------------------------------------------------------
thread_t cp_thread_create(threadproc_t proc,void *param)
{
	thread_t thread = THREAD_ERROR;
	threadparams_t *params = (threadparams_t*)malloc(sizeof(threadparams_t));

	if (!params) return THREAD_ERROR;

	params->proc = proc;
	params->param = param;
#ifdef _LINUX
	pthread_create(&thread,0,cp_thread_proc,params);
#elif defined(_WIN32)
	thread = CreateThread(0,0,cp_thread_proc,params,0,0);
#endif
	return thread;
}
//---------------------------------------------------------------------
int cp_thread_close(thread_t thread)
{
#ifdef _LINUX
	return pthread_join(thread,0);
#elif defined(_WIN32)
	if (WaitForSingleObject(thread,INFINITE) == WAIT_OBJECT_0) {
		CloseHandle(thread);
		return 0;
	}
#endif
	return -1;
}
//---------------------------------------------------------------------
